<?php
//--------------------------------------------------//
# Simple Player List by Flabaliki

# You do not need to edit this file
//--------------------------------------------------//

//Global Variables
$saveFile = "data.txt";
include "config.php";

//--------------------------------------------------//
//  The following sections writes data to the file  //
//--------------------------------------------------//

//Checks to make sure all data required was sent.
if(isset($_POST['Users']) && isset($_POST['Ranks']) && isset($_POST['ServerData']) && isset($_POST['Passcode'])){
	
	//If the sent passcode matches the configuration one, saveData is called.
	if($_POST['Passcode'] == $passcode){
		saveData($_POST['Users'], $_POST['Ranks'], $_POST['ServerData']);
	} else {
		die("Error: Passcodes do not match.");	
	}
	
	//Stop executing the file after writing data.
	die();
} else if(isset($_POST['Status']) && isset($_POST['Passcode'])){
	if($_POST['Passcode'] == $passcode){
		updateStatus($_POST['Status']);
	} else {
		die("Error: Passcodes do not match.");	
	}
	
}

function saveData($players, $ranks, $data){
	$connectArray = getLastConnect();

	$saveFile = "data.txt";
	
	//Open file for writing.
	$fh = fopen($saveFile, 'w') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");
	
	$dataToWrite = "Players=" . substr($players, 0, strlen($players) - 1) . "\n" . "Ranks=" . substr($ranks, 0, strlen($ranks) - 1) . "\n" . "ServerData=" . $data . "\n" . "Status=" . "on";
	
	//Write to and close the file
	fwrite($fh, $dataToWrite);
	fclose($fh);
	
	setLastConnect($connectArray[0], $connectArray[1]);	
}

function updateStatus($status){
	$saveFile = "data.txt";
	$fh = fopen($saveFile, 'r');
	$currentData = fread($fh, filesize($saveFile));
	fclose($fh);
	if (preg_match_all ("/(Status=)([^$\n\r]*)/is", $currentData, $matches) && ($matches[2][0] == "on" || $matches[2][0] == "off") && ($status == "on" || $status == "off")){
		$fh = fopen($saveFile, 'w') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");
		$currentData = preg_replace("/(Status=)([^$\n\r]*)/is", "Status=" . $status, $currentData);
		fwrite($fh, $currentData);
		fclose($fh);
	}
	
}

function getLastConnect(){
	//Read the last connect time
	$fh = fopen("config.php", 'r') or die("Error: Can't open config.php. On Linux, chmod this file to 664 or 666.");
	$configFile = fread($fh, filesize("config.php"));
	fclose($fh);
	
	$connectTime = 0;
	$match='(\\$lastConnection = \\d+;)';	# Word 1
	if ($c=preg_match_all ("/".$match."/is",$configFile, $matches))
	  {
		  $connectTime = substr($matches[0][0], 18, strlen(substr($matches[0][0], 18)) - 1);
	  }
	
	return array($configFile, $connectTime);
}

function setLastConnect($configFile, $connectTime){
	$fh = fopen("config.php", 'w') or die("Error: Can't open config.php. On Linux, chmod this file to 664 or 666.");
	fwrite($fh, str_replace("$" . "lastConnection = " . $connectTime . ";", "$" . "lastConnection = " . strtotime("now") . ";", $configFile));
	fclose($fh);
	
}

//--------------------------------------------------//
//  The following sections reads and displays data  //
//                   from the file                  //
//--------------------------------------------------//

//Try to create the save file if it doesn't exist.
if (!file_exists($saveFile)) {
	$fh = fopen($saveFile, 'w') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");
	fclose($fh);
} 

$fh = fopen($saveFile, 'r') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");;
$currentData = fread($fh, filesize($saveFile));
fclose($fh);

//Put each player into an element of an array.
$players = explode("\n", $currentData);
$players = explode("Players=", $players[0]);
$players = explode(",", $players[1]);

//Put each rank into an element of an array.
$ranks = explode("\n", $currentData);
$ranks = explode("Ranks=", $ranks[1]);
$ranks = explode(",", $ranks[1]);

//Put the port and slot count into their own variables.
$serverData = explode("\n", $currentData);
$serverData = explode("ServerData=", $serverData[2]);
$serverData = explode(",", $serverData[1]);
$slots = $serverData[0];
$port = $serverData[1];


//Begin printing the display
echo "<table>\n";

if (preg_match_all ("/(\\[.*?\\])/is", $template, $matches))
  {
	  foreach($matches[0] as $c){
		  switch ($c) {
			case "[Name]":
				printName($serverName);
				break;
			case "[IP]":
				printIP($port, $serverIP);
				break;
			case "[Players]":
				printPlayers($players, $ranks, $enableFaces, $faceSize);
				break;
			case "[Slots]":
				printSlots($players, $slots);
				break;
		  }
	  }
  }

echo "</table>";
//End printing the display

function printName($serverName){
	//Display server status and name.
	$connectArray = getLastConnect();
	if(serverOnline()){
		echo "\t<tr><td colspan=\"2\"><table><tr><td align=\"center\"><img src=\"images/server-on.png\" title=\"" . $serverName . " is online\"/></td><td><strong>" . $serverName . "</strong></td></tr></table></td></tr>\n";	
	} else {
		echo "\t<tr><td colspan=\"2\"><table><tr><td align=\"center\"><img src=\"images/server-off.png\" title=\"" . $serverName . " is offline\"/></td><td>" . $serverName . "</td></tr></table></td></tr>\n";	
	}
}

function serverOnline(){	
	$connectArray = getLastConnect();
	if($connectArray[1] < strtotime("-185 seconds")){
		return false;
	}
	
	$saveFile = "data.txt";
	
	$fh = fopen($saveFile, 'r') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");;
	$currentData = fread($fh, filesize($saveFile));
	fclose($fh);
	
	if(preg_match_all("/(Status=)([^$\n\r]*)/is", $currentData, $matches) && ($matches[2][0] == "off")){
		return false;	
	}
	
	return true;
}

function printIP($port, $serverIP){
	//Displays the servers IP and port.
	if($port != "25565"){
	echo "\t<tr><td colspan=\"2\" align=\"center\"><em>" . $serverIP . ":" . $port . "</em></td></tr>\n";
	} else {
		echo "\t<tr><td colspan=\"2\" align=\"center\"><em>" . $serverIP . "</em></td></tr>\n";
	}	
}

function printPlayers($players, $ranks, $enableFaces, $faceSize){
	//List out all of the players
	$count = 0;
	foreach($players as $p){
		$tag = "";
		if($ranks[$count] != ""){
			$tag = $ranks[$count] . " ";
		}
		if($players[0] != "" && $enableFaces && getFace($p, $faceSize)){
			echo "\t<tr><td colspan=\"2\"><table align=\"center\"><tr><td align=\"center\"><img src=\"images/skins/" . $p . ".png\" width=\"" . $faceSize . "px\" height=\"" . $faceSize . "px\"  title=\"" . $p . "\" /></td><td>" . $tag . $p . "</td></tr></table></td></tr>\n";
		} else if($players[0] != "" && $enableFaces) {
			echo "\t<tr><td colspan=\"2\" align=\"center\"><table><tr><td align=\"center\"><img src=\"images/skins/default.png\" width=\"" . $faceSize . "px\" height=\"" . $faceSize . "px\  title=\"" . $p . "\" /></td><td>" . $tag . $p . "</td></tr></table></td></tr>\n";
		} else {
			echo "\t<tr><td colspan=\"2\" align=\"center\">" . $tag . $p . "</td></tr>\n";
		}
		$count++;
	}	
}

function getFace($user, $faceSize) {
	//Fetches a users skin and crops to the face, then resizes it and caches it.
	//Only get the file if it doesn't exist OR it is older than 1 hour.
	if((file_exists("images/skins/" . $user . ".png") && filemtime("images/skins/" . $user . ".png") <= time()-60*60) || !file_exists("images/skins/" . $user . ".png"))  {
		if(file_exists("images/skins/" . $user . ".png")){
				unlink("images/skins/" . $user . ".png");
		}
		// Create url to users skin.
		$filename = "http://s3.amazonaws.com/MinecraftSkins/" . $user . ".png";
		$newFile = "images/skins/" . str_replace("http://s3.amazonaws.com/MinecraftSkins/", "", $filename);
		 
		 //Check that the user has a skin
		 get_headers($filename);
		 if($http_response_header[0] == "HTTP/1.1 403 Forbidden"){return false;}
		
		// Get dimensions of the original image
		list($current_width, $current_height) = getimagesize($filename);
		// The x and y coordinates on the original image where we
		// will begin cropping the image
		$left = 8;
		$top = 8;
		 
		// This will be the final size of the image (e.g. how many pixels
		// left and down we will be going)
		$crop_width = $faceSize;
		$crop_height = $faceSize;
		 
		// Resample the image
		$canvas = imagecreatetruecolor($crop_width, $crop_height);
		$current_image = imagecreatefrompng($filename);
		imagecopyresized ($canvas , $current_image , 0 , 0 , $left , $top , $crop_width * 8, $crop_height * 8, $current_width , $current_width );
		imagepng($canvas, $newFile, 9);		
		return true;
	}
	return true;
}

function printSlots($players, $slots){
	//Displays the servers current number of online users and the total number of slots
	if($players[0] != ""){
	echo "\t<tr><td colspan=\"2\" align=\"center\">" . count($players) . "/" . $slots . "</td></tr>\n";
	} else {
		echo "\t<tr><td colspan=\"2\" align=\"center\">0/" . $slots . "</td></tr>\n";
	}	
}
?>

<!--[ajax]a1[/ajax]-->